#include <conio.h>
#include <stdio.h>
#include <string.h>

#ifndef FALSE
#define FALSE 0
#endif

#ifndef TRUE
#define TRUE -1
#endif


/* function to replace dots in strings with underscores. this is because 
   as allows dots but tasm doesn't */
void undot (char *victim) {
	do {
		if (*victim == '.') {
			*victim = '_';
			printf ("{X.}");
		}
	} while (*(victim++) != '\0');
}

/* stupid functions to test whether a string is numeric, hex, or other */
/* this may not work if the system is using something other than ascii */

int ischarnum (char chr) {
	if (chr >= '0' && chr <= '9') {
		return TRUE;
	}
	if (chr == '-') return TRUE;
	return FALSE;
}

int ischarhexy (char chr) {
	if (ischarnum (chr) || (chr >= 'A' && chr <= 'F') || (chr >= 'a' && chr <= 'f')) {
		return TRUE;
	}
	return FALSE;
}

int isstrnum (char *str) {
	while (*str != '\0') {
		if (!ischarnum (*str)) return FALSE;
		++str;
	}
	return TRUE;
}

/* is str a hex number in the format 0xdddd... */
int isstrhex (char *str) {
	if (*str != '0') return FALSE;
	++str;
	if (*str != 'x') return FALSE;
	++str;
	while (*str != '\0') {
		if (!ischarhexy (*str)) return FALSE;
		++str;
	}
	return TRUE;
}



#define MAX_SYMBOL_LEN 80

/*void */

/* SEGREG:IMM(BASE,INDEX,SCALE)
   SEGREG:[IMM + BASE + INDEX*SCALE]
exception:
   IMM(,1) is [IMM] */

char read_symbol (char *symbol, FILE *in, int limit, char stopon, char stopon2, int ignore_white_space) {
	do {
		*symbol = fgetc (in);
	} while (*symbol == ' ' || *symbol == 9);


	while (*symbol != '\n' && (ignore_white_space || (*symbol != '\0' && *symbol != ' ' && *symbol != 9)) && *symbol != EOF && limit != 1) {
		if (*symbol == stopon || *symbol == stopon2) break;
			/* that last line is there because we need to consider
			   all the special things that a comma can mean.
			   It can separate operands or it can be used in
			   memory references... */
		symbol++;
		limit --;
		*symbol = fgetc (in);
	}
	/* 9 is tab */

	if (limit == 1) {
		puts ("symbol too long");
	}
	limit = *symbol;
	*symbol = '\0';
	if (limit == '\0' || limit == 9) limit = ' ';
	return (char) limit;
}


void translate_number (char *out, char *in) {
	int hexify = 0;
	*out = '\0';

	while (*in != '\0' && *in != '\n') {	/* \n is paranoia, I guess */
		if (*in == 'x') {
			hexify = TRUE;
		} else {
			*out = *in;
			++out;
		}
		++in;
	}
	if (hexify) {
		*out = 'h';
		++out;
	}
	*out = '\0';
}


/* the following procedure will either transfer immediately to a different cat
   or it will concatenate the translation of an immediate value in *in to *out
   ie $4 or 0x29 or _label, which would be translated to 4, 029h, and _label */
/* it wil also handle a reg - ie %ebx would be ebx, %st would be st, %bob would
   be bob. there is no justification for this, I can only say that this 
   function is a little misnamed */
/* it returns true if it parsed something that calls for an instruction suffix
   to be removed. this includes:
   registers, but not %st. NOT!!! NOT NOT NOT NOT NOT!!! N-O-T!!! it turned
   out that it would always return true then, so we used the return value
   for something useful */
/* will return whether it encountered a register, a constant, or an unknown,
   ie a label */
#define REGISTER 1 /* these are pretty much arbitrary, they are used to figure */
#define CONSTANT 2 /* out when a (D)WORD/BYTE PTR is needed. I wonder what */
#define UNKNOWN 4  /* to do about QWORD? Maybe it's not really necessary to */
#define MEMORY 8   /* worry about it... */
#define FPUSTACK 16
int transcat_immediate (char *out, char *in) {
	if (in[0] == '\0') return 0;
	if (in[0] == '%') {
		printf ("{reg/st(0)}");
		strcat (out, &in[1]);
		return REGISTER;
	}
	if (in[0] == '$') {
		printf ("{arg! imm or offset?}");
		if (isstrnum (&in[1]) || isstrhex (&in[1])) {
			printf ("{imm!}");
			while (*out) ++out; /* to perform concatenation */
			translate_number (out, &in[1]);
			return CONSTANT;
		} else {
			printf ("{offset?}");
			undot (&in[1]);
			strcat (out, "(offset ");
			strcat (out, &in[1]);
			strcat (out, ")");
			return CONSTANT;
		}
	} else {
		printf ("{imm?}");
		if (isstrnum (in) || isstrhex (in)) {
			printf ("{imm!}");
			while (*out) ++out; /* "" */ 
			translate_number (out, in);
			return CONSTANT;
		} else {
			printf ("{Eh?}");
			undot (in);
			if (*in == '*') {
				printf ("{THE ONE!}");
				strcat (out, &in[1]);
			} else {
				strcat (out, in);
			}
			return UNKNOWN;  /* btw, it's probably a label */
		}
	}
}


/* 1st symbol is opcode (or label or preprocessor directive)
   then read symbols into array
   check for comma 
   ...
   ...
   ...
   (check for coma) */
   

#define MAX_SYMBOLS 10

/* SEGREG:IMM(BASE,INDEX,SCALE)
   SEGREG:[IMM + BASE + INDEX*SCALE]
exception:
   IMM(,1) is [IMM] */

/* reasons for stripping instruction suffix */
/* bits in a bitfield, so they are powers of two */
#define MEMREF 1
#define OTHER 2

/* the word divine is used here as a verb, as in the process of divination */
/* returns true if there are more arguments to be had on this line */
/* argtype will basically store what transcat_immediate returns, or MEMORY,
   or FPUSTACK */
int divine_arg (char *intelarg, FILE *in, char *command, char delim, char suffix, int *argtype, int *stripped) {
	char symbols[MAX_SYMBOLS][MAX_SYMBOL_LEN];
	char delim_array[MAX_SYMBOLS];
	int n;
	char *tmp = "\0\0";
	int cur_symbol = 0;
	int moreoperands = FALSE;
	int stripit = 0; /* whether to strip instruction suffixes */
	char tmp1;

	*intelarg = '\0';


	do {
		delim_array[cur_symbol] = read_symbol (symbols[cur_symbol], in, MAX_SYMBOL_LEN, ',', '(', TRUE);
		printf ("%s%c", symbols[cur_symbol], delim_array[cur_symbol]);

		if (delim_array[cur_symbol] == '(') {
			printf ("{ fpu op or memory ref }");
			if (!strcmp ("%st", symbols[cur_symbol])) {
				printf ("{FPU!}");
				strcat (intelarg, " st(");
				do {
					*tmp = fgetc (in);
					strcat (intelarg, tmp);
				} while (*tmp != ')');
				*argtype = FPUSTACK;
			} else {
				printf ("{Ref! :");
				stripit |= MEMREF;
				*argtype = MEMORY;

				/* look for segreg */
				n = 0;
				while (symbols[cur_symbol][n] != '\0' && symbols[cur_symbol][n] != ':') ++n;
				if (symbols[cur_symbol][n] == ':') { /* segreg! */
					printf("S");
					symbols[cur_symbol][n] = '\0'; /* split string into segreg and imm */
					transcat_immediate (intelarg, symbols[cur_symbol]);
					strcat (intelarg, ":[");
					++n;
				} else {
					n = 0; /* no segreg, so imm will start
					          at [0] of string, if at all */
					strcat (intelarg, "[");
				}
				if (symbols[cur_symbol][n] != '\0') { /* displacement! */
					printf ("d");
					transcat_immediate (intelarg, &symbols[cur_symbol][n]);
				}
				
				/* next we shall read BASE */
				/* ++cur_symbol;
				if (cur_symbol == MAX_SYMBOLS) {
					fprintf (stderr, "ran out of symbol space while trying to do something!");
					exit (255);
				} */
				
				delim_array[cur_symbol] = read_symbol (symbols[cur_symbol], in, MAX_SYMBOL_LEN, ',', ')', TRUE);
				
				if (symbols[cur_symbol][0] != '\0') { /* BASE! */
					printf("b");
					if (intelarg[strlen (intelarg) - 1] != '[') strcat (intelarg, "+");
					transcat_immediate (intelarg, symbols[cur_symbol]);
				}
				
				++cur_symbol;
				if (cur_symbol == MAX_SYMBOLS) {
					fprintf (stderr, "ran out of symbol space while trying to do something!");
					exit (255);
				}

				/* try to read INDEX */
				delim_array[cur_symbol] = read_symbol (symbols[cur_symbol], in, MAX_SYMBOL_LEN, ',', ')', TRUE);

				if (delim_array[cur_symbol - 1] == ')') {
					printf ("}");
					strcat (intelarg, "]");
				} else {
					if (symbols[cur_symbol] != '\0' && !!strcmp(symbols[cur_symbol], "1")) { /* INDEX */
						printf("i");
						if (intelarg[strlen (intelarg) - 1] != '[') strcat (intelarg, "+");
						transcat_immediate (intelarg, symbols[cur_symbol]);
					}

					if (delim_array[cur_symbol] == ')') {
						printf ("}");
						strcat (intelarg, "]");
					} else {
						/* try to read SCALE */
						printf ("s");
						delim_array[cur_symbol] = read_symbol (symbols[cur_symbol], in, MAX_SYMBOL_LEN, ',', ')', TRUE);
						if (symbols[cur_symbol][0] == '\0') printf ("I've broken it!!!");
						strcat (intelarg, "*");
						transcat_immediate (intelarg, symbols[cur_symbol]);
						strcat (intelarg, "]");
					}
				}
			}
		}
		
		if (delim_array[cur_symbol] == ',') {
			printf ("{Next Operand}");
			moreoperands = TRUE;
			++cur_symbol;	
			break;
		}

		++cur_symbol;

	} while (delim_array[cur_symbol - 1] != '\n' && delim_array[cur_symbol - 1] != EOF && cur_symbol < MAX_SYMBOLS);

	if (cur_symbol == MAX_SYMBOLS) {
		puts ("Too many arguments in line!");
	}

	/* check for immediate numerical constant or immediate label offset */
	/* an offset is apparently preceded by a '$', ie the offset of */
	/* Label: is $Label */
	/* Note that if cur_symbol != 1 then the arguments have already been
	   dealt with */

	if (cur_symbol == 1) { /* this means only 1 or 0 symbol(s) were found, I hope */
		printf ("{1 s.}");
		stripit |= OTHER;
		*argtype = transcat_immediate (intelarg, symbols[0]);
		if (!strcmp ("%st", symbols[0])) { 
			stripit &= MEMREF;
			*argtype = FPUSTACK;
		}
	}

	if (!strcmp ("call", command)) stripit = 0;
	tmp1  = command[strlen (command) - 1];
	if (tmp1 != 'b' && tmp1 != 'w' && tmp1 != 'l' && !((tmp1 == 't' || tmp1 == 's') && command[0] == 'f') ) stripit = 0;
	if (stripit && !*stripped) {
		command[strlen (command) - 1] = '\0';
		*stripped = TRUE;
	}

	return moreoperands;
}

/* firstchar is the first character of the instruction. This is needed to
   distinguish FPU instructions from other instructions since FPU instrucion
   suffixes mean different things than the suffixes on normal instructions */
void print_ptr (FILE *out, char suffix, char *command) {
	if (command[0] == 'f') {
		switch (suffix) {
			case 't':
				fprintf (out, "TBYTE PTR ");
				break;
			case 'l':
				fprintf (out, "QWORD PTR ");
				break;
			case 's':
				fprintf (out, "DWORD PTR ");
				break;
			default:
			printf ("Shut up, Mr. Gumby!!!");
		}
	} else {
		switch (suffix) {
			case 'l':
				fprintf (out, "DWORD PTR ");
				break;
			case 'w':
				fprintf (out, "WORD PTR ");
				break;
			case 'b':
				fprintf (out, "BYTE PTR ");
				break;
			default:
				/* a jmp table, ie switch/case will use this, I think */
				/* I have no idea if gcc would ever generate a 
				   call with a memory reference (ie "call [ebx]"), it would be
				   kind of demented, I think... */
				if (command[0] == 'j' || !strcmp (command, "call")) { 
					fprintf (out, "DWORD PTR "); 
					/* Depending on what the hell you're 
					   doing, this could end up being
					   *very* wrong! */
				} else {
					printf ("I've got my head stuck in the cupboard again!!!");
				}
		}
	}
}

void do_ptr (FILE *out, char *command, char suffix, int argtype) {
	switch (argtype) {
		case MEMORY:
			print_ptr (out, suffix, command);
			break;
		case REGISTER:
			break;	
		case CONSTANT:
			if (!strcmp (command, "push")) {
				print_ptr (out, suffix, command);
			}
			break;
		case UNKNOWN:
			if (!strcmp (command, "call") || *command == 'j') {
				break;
			}
			print_ptr (out, suffix, command);
			break;
		case FPUSTACK:
			break;
		default:
			printf ("*CRACK* *CRASH* *Open the door* and come in!!!");
	}
}






int parse_line (FILE *in, FILE *out) {
	char symbol1[MAX_SYMBOL_LEN];
	int stripped=0;
	char delimiter;
	char tmp;
	int tmpoctal;

	char ptrsize[3];
	/* two characters representing the dword/word/byte ptr ripped directly
	   from the AT&T instruction. with something like movsbw they'll be
	   {'b','w'} with a movb they'll be {'b','b'} 
	   there are really only two significant characters there. the 3rd
	   is always a '\0' so the array is a valid asciiz string which will
	   allow it to be used with strcat*/

	char args[2][MAX_SYMBOL_LEN]; /* 2 parameters */
	/* two strings containing the Intel syntax operands, derived from the
	   AT&T source, in AT&T order */

	int argtypes[2] = {0, 0};
	/* two integers indicating the type of argument, ie MEMORY, FPUSTACK
	   in the same order as args[][] */

	/* Init */
	args[0][0] = '\0';
	args[1][0] = '\0';


	/* no special characters to check for, thus "0, 0" */
	/* read preproc directive, instruction, label, or comment */
	delimiter = read_symbol (symbol1, in, MAX_SYMBOL_LEN, 0, 0, FALSE);
        printf ("%s%c", symbol1, delimiter);

        /* check for comments first */
	/* do this later, since gcc doesn't generate comments */

        /* check for... hm... let's see... label */
        if (symbol1 [strlen (symbol1) - 1] == ':') {
		undot (symbol1);
                fprintf (out, "%s ; basic label\n", symbol1);
		return -1;
        }

	if (symbol1[0] == '/') {
		fprintf (out, " ; %s\n", symbol1);
		return -1;
	}

	/* check for preprocessor directives here */
	if (symbol1[0] == '.') {
		printf ("{preproc}");
		if (!strcmp (".ascii", symbol1)) {
			fprintf (out, "db ");
			printf ("{.ascii, copy the rest as db}\n");
			do {
				tmp = fgetc (in);
				sim_fgetc:;
				if (tmp == '\\') {
					tmp = fgetc (in);
					if (tmp == 'n'){
						fputc ('"', out);
						fprintf (out, ", 0Dh, 0Ah, ");
						fputc ('"', out);
					} else if (tmp == '\\') {
						fputc ('\\', out);
					} else if (tmp >= '0' && tmp <= '9') {
						tmpoctal = 0;
						while (tmp >= '0' && tmp <= '9') {
							tmpoctal *= 8;
							if (tmp == '8') {
								tmpoctal += 10;
							} else if (tmp == '9') {
								tmpoctal += 11;
							} else {
								tmpoctal += (tmp - '0');
							}
							tmp = fgetc (in);
						}
						fputc ('"', out);
						fprintf (out, ", %d, ", tmpoctal);
						fputc ('"', out);
						goto sim_fgetc; /* Aaargh! I'm sorry!!! :) */
					} else {
						fprintf (out, "\\%c", tmp);
						printf ("I don't get it!");
					}
				} else {
					fputc (tmp, out);
				}
			} while (tmp != '\n' && tmp != EOF);
			return -1;
		}
		if (!strcmp (".long", symbol1) || !strcmp (".int", symbol1) || !strcmp(".byte", symbol1) || !strcmp(".word", symbol1)) {
			printf ("{list of numbers}");
			if (!strcmp (".byte", symbol1)) fprintf (out, "db ");
			if (!strcmp (".word", symbol1)) fprintf (out, "dw ");
			if (!strcmp (".long", symbol1) || !strcmp (".int", symbol1)) fprintf (out, "dd ");
			do {
				tmp = divine_arg (args[0], in, symbol1, delimiter, '\0', argtypes, &stripped);
				fprintf (out, " %s", args[0]);
				if (tmp) fprintf (out, ",");
			} while (tmp);
			fprintf (out, "\n");
			return -1;
		}
		if (!strcmp (".comm", symbol1)) {
			printf ("{.comm to dup(?)}");
			tmp = divine_arg (args[0], in, symbol1, delimiter, '\0', argtypes, &stripped);
			if (!tmp) printf ("{BROKEN .COMM!!!}");
			tmp = divine_arg (args[1], in, symbol1, delimiter, '\0', argtypes, &stripped);
			if (tmp) printf ("{MILDLY DEFECTIVE .COMM!!!}");
			fprintf (out, "public %s\n%s  db %s dup(?)\n", args[0], args[0], args[1]);
			return -1;
		}
		if (!strcmp (".lcomm", symbol1)) {
			printf ("{.lcomm to dup(?)}");
			tmp = divine_arg (args[0], in, symbol1, delimiter, '\0', argtypes, &stripped);
			if (!tmp) printf ("{BROKEN .LCOMM!!!}");
			tmp = divine_arg (args[1], in, symbol1, delimiter, '\0', argtypes, &stripped);
			if (tmp) printf ("{MILDLY DEFECTIVE .LCOMM!!!}");
			fprintf (out, "%s  db %s dup(?)\n", args[0], args[1]);
			return -1;
		}
		if (!strcmp (".globl", symbol1)) {
			printf ("{.globl}");
			tmp = divine_arg (args[0], in, symbol1, delimiter, '\0', argtypes, &stripped);
			if (!tmp) printf ("{dead!}");
			fprintf (out, "public %s\n", args[0]);
			return -1;
		}
		if (!strcmp (".align", symbol1)) {
			printf ("{align}");
			tmp = divine_arg (args[0], in, symbol1, delimiter, '\0', argtypes, &stripped);
			if (tmp) while ((tmp = fgetc (in)) != '\n');
			fprintf (out, "\nalign %s\n", args[0]);
			return -1;
		}


		/*if (!strcmp (".text", symbol1)) {
			printf ("{section start}");
			fprintf (out, "code32 segment para public use32\nassume cs:code32, ds:code32\n");
			return -1;
		}*/ /* This is not the way it's going to work. everything
		       will be in the Code32 segment and parse_file will put
		       that in. */
		printf ("{??? trash comments}\n");
		fprintf (out, " ; %s%c", symbol1, delimiter);
		tmp = delimiter;
		while (tmp != '\n' && tmp != EOF) {
			tmp = fgetc (in);
			fputc (tmp, out);
		}
		if (tmp == EOF) return FALSE;
		return TRUE;
	}
	/* ... */


	/* change retarded instructions that are named differently in at&t */
	if (!strcmp ("cbtw", symbol1)) {
		strcpy (symbol1, "cbw");
	} else if (!strcmp ("cwtl", symbol1)) {
		strcpy (symbol1, "cwde");
	} else if (!strcmp ("cwtd", symbol1)) {
		strcpy (symbol1, "cwd");
	} else if (!strcmp ("cltd", symbol1)) {
		strcpy (symbol1, "cdq");
	} /* other retarded instructions such as movsbw and ljmp are not
	     included here because they take parameters and are dealt with
	     later */


	/* obviously there won't be any arguments if it's an EOL, so quit */
	if (delimiter == '\n') {
		fprintf (out, "%s\n", symbol1);
                puts (" ;EOL");
		return -1;
	}


	/* set the memory reference size character array information bearing
	   support structure to contain the appropriate bytes as they relate
	   to the memory reference data type size in the current instruction */
	/* and stuff */
	if (!strcmp ("lcall", symbol1)) {
		strcpy (symbol1, "call far ");
	} else if (!strcmp ("ljmp", symbol1)) {
		strcpy (symbol1, "jmp far ");
	} else if (!strcmp ("movsbw", symbol1) || !strcmp ("movsbl", symbol1) \
		|| !strcmp ("movswl", symbol1) || !strcmp ("movzbw", symbol1) \
		|| !strcmp ("movzbl", symbol1) || !strcmp ("movzwl", symbol1))
	{
		strcpy (ptrsize, &symbol1[4]);
		strcpy (&symbol1[4], "x");
	} else {
		ptrsize[0] = ptrsize[1] = symbol1[strlen (symbol1) - 1];
	}

	/* parse arguments. divine_arg will also take the liberty of stripping
	   memory reference size indicator characters, such as the 'b' in
	   movb. I think this is a valid place to do it because the suffix
	   isn't part of the instruction, as far as I'm concerned. That
	   information goes with arguments. */
	if (divine_arg (args[0], in, symbol1, delimiter, ptrsize[0], argtypes, &stripped)) {
		divine_arg (args[1], in, symbol1, delimiter, ptrsize[1], &argtypes[1], &stripped);
	}


	/* print arguments. Really check for exceptions first. (see above) */

	fprintf (out, "%s ", symbol1);

	if (args[1][0] == '\0') {
		fputc (9, out); /* tab */
		do_ptr (out, symbol1, ptrsize[0], argtypes[0]);
		fprintf (out, "%s\n", args[0]);
	} else {
		fputc (9, out); /* tab */
		do_ptr (out, symbol1, ptrsize[1], argtypes[1]);
		fprintf (out, "%s,", args[1]);
		do_ptr (out, symbol1, ptrsize[0], argtypes[0]);
		fprintf (out, "%s\n", args[0]);
	}

	if (delimiter == EOF) return 0;
	printf ("{nothing more?}");
	return -1;
}


void parse_file (FILE *in, FILE *out) {
	fprintf (out, ".386p\n");
	fprintf (out, "Code32 segment para public use32\n");
	fprintf (out, "assume cs:Code32, ds:Code32\n");
	while (parse_line (in, out)) {
		asm ("nop;");
	};
	fprintf (out, "Code32 ends\n");
	fprintf (out, "end\n");
}